# coding: utf-8

"""
    Nucleus API

    Nucleus text analytics APIs from SumUp Analytics. Example and documentation: https://github.com/SumUpAnalytics/nucleus-sdk  # noqa: E501

    OpenAPI spec version: v2.3.2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class DocumentContrastSummaryModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'dataset': 'str',
        'query': 'str',
        'metadata_selection': 'object',
        'custom_stop_words': 'list[str]',
        'time_period': 'str',
        'period_start': 'str',
        'period_end': 'str',
        'summary_length': 'int',
        'context_amount': 'int',
        'short_sentence_length': 'int',
        'long_sentence_length': 'int',
        'excluded_docs': 'list[str]',
        'syntax_variables': 'bool',
        'compression': 'float',
        'remove_redundancies': 'bool'
    }

    attribute_map = {
        'dataset': 'dataset',
        'query': 'query',
        'metadata_selection': 'metadata_selection',
        'custom_stop_words': 'custom_stop_words',
        'time_period': 'time_period',
        'period_start': 'period_start',
        'period_end': 'period_end',
        'summary_length': 'summary_length',
        'context_amount': 'context_amount',
        'short_sentence_length': 'short_sentence_length',
        'long_sentence_length': 'long_sentence_length',
        'excluded_docs': 'excluded_docs',
        'syntax_variables': 'syntax_variables',
        'compression': 'compression',
        'remove_redundancies': 'remove_redundancies'
    }

    def __init__(self, dataset=None, query=None, metadata_selection=None, custom_stop_words=None, time_period=None, period_start=None, period_end=None, summary_length=None, context_amount=None, short_sentence_length=None, long_sentence_length=None, excluded_docs=None, syntax_variables=False, compression=None, remove_redundancies=True):  # noqa: E501
        """DocumentContrastSummaryModel - a model defined in Swagger"""  # noqa: E501

        self._dataset = None
        self._query = None
        self._metadata_selection = None
        self._custom_stop_words = None
        self._time_period = None
        self._period_start = None
        self._period_end = None
        self._summary_length = None
        self._context_amount = None
        self._short_sentence_length = None
        self._long_sentence_length = None
        self._excluded_docs = None
        self._syntax_variables = None
        self._compression = None
        self._remove_redundancies = None
        self.discriminator = None

        self.dataset = dataset
        if query is not None:
            self.query = query
        self.metadata_selection = metadata_selection
        if custom_stop_words is not None:
            self.custom_stop_words = custom_stop_words
        if time_period is not None:
            self.time_period = time_period
        if period_start is not None:
            self.period_start = period_start
        if period_end is not None:
            self.period_end = period_end
        if summary_length is not None:
            self.summary_length = summary_length
        if context_amount is not None:
            self.context_amount = context_amount
        if short_sentence_length is not None:
            self.short_sentence_length = short_sentence_length
        if long_sentence_length is not None:
            self.long_sentence_length = long_sentence_length
        if excluded_docs is not None:
            self.excluded_docs = excluded_docs
        if syntax_variables is not None:
            self.syntax_variables = syntax_variables
        if compression is not None:
            self.compression = compression
        if remove_redundancies is not None:
            self.remove_redundancies = remove_redundancies

    @property
    def dataset(self):
        """Gets the dataset of this DocumentContrastSummaryModel.  # noqa: E501

        Dataset name.  # noqa: E501

        :return: The dataset of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: str
        """
        return self._dataset

    @dataset.setter
    def dataset(self, dataset):
        """Sets the dataset of this DocumentContrastSummaryModel.

        Dataset name.  # noqa: E501

        :param dataset: The dataset of this DocumentContrastSummaryModel.  # noqa: E501
        :type: str
        """
        if dataset is None:
            raise ValueError("Invalid value for `dataset`, must not be `None`")  # noqa: E501

        self._dataset = dataset

    @property
    def query(self):
        """Gets the query of this DocumentContrastSummaryModel.  # noqa: E501

        Dataset-language-specific fulltext query, using mysql MATCH boolean query format. Example: \"(word1 OR word2) AND (word3 OR word4)\"   # noqa: E501

        :return: The query of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """Sets the query of this DocumentContrastSummaryModel.

        Dataset-language-specific fulltext query, using mysql MATCH boolean query format. Example: \"(word1 OR word2) AND (word3 OR word4)\"   # noqa: E501

        :param query: The query of this DocumentContrastSummaryModel.  # noqa: E501
        :type: str
        """

        self._query = query

    @property
    def metadata_selection(self):
        """Gets the metadata_selection of this DocumentContrastSummaryModel.  # noqa: E501

        JSON object specifying the 2 classes subject to contrasted summarization, of type: if based on content-selection {\"content\": \"word1 word2 ... wordN\"} ; if based on other field {\"metadata_field\": [\"values_class1\", \"values_class2\"}  # noqa: E501

        :return: The metadata_selection of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: object
        """
        return self._metadata_selection

    @metadata_selection.setter
    def metadata_selection(self, metadata_selection):
        """Sets the metadata_selection of this DocumentContrastSummaryModel.

        JSON object specifying the 2 classes subject to contrasted summarization, of type: if based on content-selection {\"content\": \"word1 word2 ... wordN\"} ; if based on other field {\"metadata_field\": [\"values_class1\", \"values_class2\"}  # noqa: E501

        :param metadata_selection: The metadata_selection of this DocumentContrastSummaryModel.  # noqa: E501
        :type: object
        """
        if metadata_selection is None:
            raise ValueError("Invalid value for `metadata_selection`, must not be `None`")  # noqa: E501

        self._metadata_selection = metadata_selection

    @property
    def custom_stop_words(self):
        """Gets the custom_stop_words of this DocumentContrastSummaryModel.  # noqa: E501


        :return: The custom_stop_words of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._custom_stop_words

    @custom_stop_words.setter
    def custom_stop_words(self, custom_stop_words):
        """Sets the custom_stop_words of this DocumentContrastSummaryModel.


        :param custom_stop_words: The custom_stop_words of this DocumentContrastSummaryModel.  # noqa: E501
        :type: list[str]
        """

        self._custom_stop_words = custom_stop_words

    @property
    def time_period(self):
        """Gets the time_period of this DocumentContrastSummaryModel.  # noqa: E501

        Alternative 1: Time period selection from now  # noqa: E501

        :return: The time_period of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: str
        """
        return self._time_period

    @time_period.setter
    def time_period(self, time_period):
        """Sets the time_period of this DocumentContrastSummaryModel.

        Alternative 1: Time period selection from now  # noqa: E501

        :param time_period: The time_period of this DocumentContrastSummaryModel.  # noqa: E501
        :type: str
        """

        self._time_period = time_period

    @property
    def period_start(self):
        """Gets the period_start of this DocumentContrastSummaryModel.  # noqa: E501

        Alternative 2: Start date for the period to analyze within the dataset. Format: \"YYYY-MM-DD\"   # noqa: E501

        :return: The period_start of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: str
        """
        return self._period_start

    @period_start.setter
    def period_start(self, period_start):
        """Sets the period_start of this DocumentContrastSummaryModel.

        Alternative 2: Start date for the period to analyze within the dataset. Format: \"YYYY-MM-DD\"   # noqa: E501

        :param period_start: The period_start of this DocumentContrastSummaryModel.  # noqa: E501
        :type: str
        """

        self._period_start = period_start

    @property
    def period_end(self):
        """Gets the period_end of this DocumentContrastSummaryModel.  # noqa: E501

        Alternative 2: End date for the period to analyze within the dataset. Format: \"YYYY-MM-DD\"   # noqa: E501

        :return: The period_end of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: str
        """
        return self._period_end

    @period_end.setter
    def period_end(self, period_end):
        """Sets the period_end of this DocumentContrastSummaryModel.

        Alternative 2: End date for the period to analyze within the dataset. Format: \"YYYY-MM-DD\"   # noqa: E501

        :param period_end: The period_end of this DocumentContrastSummaryModel.  # noqa: E501
        :type: str
        """

        self._period_end = period_end

    @property
    def summary_length(self):
        """Gets the summary_length of this DocumentContrastSummaryModel.  # noqa: E501

        The maximum number of bullet points a user wants to see in each topic summary.  # noqa: E501

        :return: The summary_length of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: int
        """
        return self._summary_length

    @summary_length.setter
    def summary_length(self, summary_length):
        """Sets the summary_length of this DocumentContrastSummaryModel.

        The maximum number of bullet points a user wants to see in each topic summary.  # noqa: E501

        :param summary_length: The summary_length of this DocumentContrastSummaryModel.  # noqa: E501
        :type: int
        """

        self._summary_length = summary_length

    @property
    def context_amount(self):
        """Gets the context_amount of this DocumentContrastSummaryModel.  # noqa: E501

        The number of sentences surrounding key summary sentences in the documents that they come from.  # noqa: E501

        :return: The context_amount of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: int
        """
        return self._context_amount

    @context_amount.setter
    def context_amount(self, context_amount):
        """Sets the context_amount of this DocumentContrastSummaryModel.

        The number of sentences surrounding key summary sentences in the documents that they come from.  # noqa: E501

        :param context_amount: The context_amount of this DocumentContrastSummaryModel.  # noqa: E501
        :type: int
        """

        self._context_amount = context_amount

    @property
    def short_sentence_length(self):
        """Gets the short_sentence_length of this DocumentContrastSummaryModel.  # noqa: E501

        The sentence length (in number of words) below which a sentence is excluded from summarization.  # noqa: E501

        :return: The short_sentence_length of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: int
        """
        return self._short_sentence_length

    @short_sentence_length.setter
    def short_sentence_length(self, short_sentence_length):
        """Sets the short_sentence_length of this DocumentContrastSummaryModel.

        The sentence length (in number of words) below which a sentence is excluded from summarization.  # noqa: E501

        :param short_sentence_length: The short_sentence_length of this DocumentContrastSummaryModel.  # noqa: E501
        :type: int
        """

        self._short_sentence_length = short_sentence_length

    @property
    def long_sentence_length(self):
        """Gets the long_sentence_length of this DocumentContrastSummaryModel.  # noqa: E501

        The sentence length (in number of words) beyond which a sentence is excluded from summarization.  # noqa: E501

        :return: The long_sentence_length of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: int
        """
        return self._long_sentence_length

    @long_sentence_length.setter
    def long_sentence_length(self, long_sentence_length):
        """Sets the long_sentence_length of this DocumentContrastSummaryModel.

        The sentence length (in number of words) beyond which a sentence is excluded from summarization.  # noqa: E501

        :param long_sentence_length: The long_sentence_length of this DocumentContrastSummaryModel.  # noqa: E501
        :type: int
        """

        self._long_sentence_length = long_sentence_length

    @property
    def excluded_docs(self):
        """Gets the excluded_docs of this DocumentContrastSummaryModel.  # noqa: E501


        :return: The excluded_docs of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._excluded_docs

    @excluded_docs.setter
    def excluded_docs(self, excluded_docs):
        """Sets the excluded_docs of this DocumentContrastSummaryModel.


        :param excluded_docs: The excluded_docs of this DocumentContrastSummaryModel.  # noqa: E501
        :type: list[str]
        """

        self._excluded_docs = excluded_docs

    @property
    def syntax_variables(self):
        """Gets the syntax_variables of this DocumentContrastSummaryModel.  # noqa: E501

        If True, the contrasted summary will leverage syntax-related variables on top of content variables to better separate the document from the rest  # noqa: E501

        :return: The syntax_variables of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: bool
        """
        return self._syntax_variables

    @syntax_variables.setter
    def syntax_variables(self, syntax_variables):
        """Sets the syntax_variables of this DocumentContrastSummaryModel.

        If True, the contrasted summary will leverage syntax-related variables on top of content variables to better separate the document from the rest  # noqa: E501

        :param syntax_variables: The syntax_variables of this DocumentContrastSummaryModel.  # noqa: E501
        :type: bool
        """

        self._syntax_variables = syntax_variables

    @property
    def compression(self):
        """Gets the compression of this DocumentContrastSummaryModel.  # noqa: E501

        Parameter controlling the breadth of the contrasted summary. Contained between 0 and 1, the smaller it is, the more contrasting terms will be captured, with decreasing weight.  # noqa: E501

        :return: The compression of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: float
        """
        return self._compression

    @compression.setter
    def compression(self, compression):
        """Sets the compression of this DocumentContrastSummaryModel.

        Parameter controlling the breadth of the contrasted summary. Contained between 0 and 1, the smaller it is, the more contrasting terms will be captured, with decreasing weight.  # noqa: E501

        :param compression: The compression of this DocumentContrastSummaryModel.  # noqa: E501
        :type: float
        """

        self._compression = compression

    @property
    def remove_redundancies(self):
        """Gets the remove_redundancies of this DocumentContrastSummaryModel.  # noqa: E501

        If True, this option removes quasi-duplicates from the analysis. A quasi-duplicate would have the same NLP representation, but not necessarily the exact same text.  # noqa: E501

        :return: The remove_redundancies of this DocumentContrastSummaryModel.  # noqa: E501
        :rtype: bool
        """
        return self._remove_redundancies

    @remove_redundancies.setter
    def remove_redundancies(self, remove_redundancies):
        """Sets the remove_redundancies of this DocumentContrastSummaryModel.

        If True, this option removes quasi-duplicates from the analysis. A quasi-duplicate would have the same NLP representation, but not necessarily the exact same text.  # noqa: E501

        :param remove_redundancies: The remove_redundancies of this DocumentContrastSummaryModel.  # noqa: E501
        :type: bool
        """

        self._remove_redundancies = remove_redundancies

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DocumentContrastSummaryModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DocumentContrastSummaryModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
